<template>
    <StackLayout id="searching" class="align-center" :class="platform" @tap="clearFocus">
      <StackLayout id="filler">
          
      </StackLayout>
        <Label textWrap="true" text="Which city are you looking for today ?"
            class="h2 bold" />
        <FlexboxLayout padding="16" borderRadius="16" backgroundColor="#ffffff"
            class="input-container" width="300" alignItems="center"
            justifyContent="center">
            <!-- <Image src="~/assets/icons/Search-Red.png" height="20" minWidth="20"
                margin="0 12" /> -->
            <Label class="fas" :text="'fa-search' | fonticon"  fontSize="20" height="20" minWidth="20" margin="0 12" color="#53ba82" textWrap="true" />
            <TextView :width="searchBarWidth" editable="true" v-model="searchQuery" color="#53ba82"
                hint="ex: Paris, Tokyo..." class="input extra-bold" :class="{empty: (searchQuery == '')}"
                ref="searchBar" @tap="searchTapped">
            </TextView>
            <!-- <Image src="~/assets/icons/Cross-red.png" height="16" minWidth="16"
                margin="0 14" @tap="searchQuery = ''" /> -->
            <Label 
              class="fas" :text="'fa-times' | fonticon"  margin="0 14" fontSize="20" height="20" minWidth="20" color="#53ba82" textWrap="true" 
              @tap="searchQuery = ''"
            />
            
        </FlexboxLayout>
        <ScrollView orientation="horizontal" height="50">
            <FlexboxLayout alignItems="center" justifyContent="center">
                <Label :text="city" v-for="(city,index) in filteredCities"
                    :key="index" padding="12" height="100%" class="city bold"
                    @tap="goToCityOverview(city)" />
            </FlexboxLayout>
        </ScrollView>
        <Label fontSize="30" @tap="toggleSearch" :text="'fa-times' | fonticon" class="fas close" />
    </StackLayout>
</template>

<script>
    // import CityOverview from "./CityOverview";
  const application = require("tns-core-modules/application");

  export default {
      methods: {
          toggleSearch() {
              this.$emit("toggleSearch");
          },
          clearFocus() {
              this.$refs.searchBar.nativeView.dismissSoftInput();
          },
          tappedSearchBar() {
            const focusOnSearch = this.$refs.search
          },
          searchTapped() {
            this.searchFocused = true
          }
      },

      mounted() {
          //this.searchQuery = "";
          //if (application.android) {
          //setTimeout(() => {
          //this.clearFocus();
          // }, 100);
          // } else if (application.ios) {
          //  setTimeout(() => {
          //      this.searchBarWidth = "100%";
          // }, 500);
          // }

          if (application.ios) {
              this.platform = "ios";
              setTimeout(() => {
                  this.searchBarWidth = "100%";
              }, 500);
          } else if (application.android) {
              this.platform = "android";
          }
      },

      computed: {
          filteredCities() {
              if (this.searchQuery !== "") {
                  return this.cities.filter(city =>
                      city.toLowerCase().includes(this.searchQuery.toLowerCase())
                  );
              }
          }
      },

      data() {
          return {
            searchFocused: false,
              platform: "",
              searchBarWidth: "0%",
              // cityOverviewPage: CityOverview,
              searchQuery: "",
              cities: [
                  "Johannesburg",
                  "Berlin",
                  "Toronto",
                  "Mumbai",
                  "Munich",
                  "Madrid",
                  "Dublin",
                  "Chennai",
                  "India",
                  "Los Angeles",
                  "Miami",
                  "Prague",
                  "Vienna",
                  "Shanghai",
                  "Rome",
                  "Taipei",
                  "Osaka",
                  "Milan",
                  "Amsterdam",
                  "Barcelona",
                  "Istanbul",
                  "Hong Kong",
                  "Kuala Lumpur",
                  "New York",
                  "Seoul",
                  "Tokyo",
                  "Singapore",
                  "Dubai",
                  "Paris",
                  "London",
                  "Bangkok"
              ]
          };
      }
  }
</script>

<style scoped>
  .align-center {
    text-align: center; 
  }
  .extra-bold{
    /* font-family: "Assistant-ExtraBold","Assistant ExtraBold"; */
    /* font-family: 'Assistant', sans-serif; */
    font-weight: 800;
  }

  .bold{
      /* font-family: "Assistant-Bold","Assistant"; */
      /* font-family: 'Assistant', sans-serif; */
      font-weight: 700;
  }

  .semi-bold{
      /* font-family: "Assistant-SemiBold","Assistant SemiBold"; */
      /* font-family: 'Assistant', sans-serif; */
      font-weight: 600;
  }
  #filler {
    padding: 100 25;
  }
  
  #searching {
    padding: 0 25;
    background: linear-gradient(-45deg, #53ba82, #52a578);
  }

    #searching .city {
      color: #ffffff;
      font-size: 16;

    }

    #searching .h2 {
        font-size: 18;
        margin-bottom: 40;
        color: #ffffff;
    }

    #searching .input-container {
        opacity: 0;
        animation-name: bounceIn;
        animation-duration: 1s;
        animation-fill-mode: forwards;
        animation-delay: 0s;
    }

    #searching .input {
        background-color: #ffffff;
        height: 60;
        text-decoration: none;
        font-size: 35;
        text-align: left;
        width: 100%;
        flex-grow: 2;
    }

    #searching.ios .input {
        padding-top: 10;
    }

    #searching .input.empty {
        font-size: 16;
        padding-top: 19;
    }

    #searching .close {
        height: 40;
        width: 40;
        /* background-image: ~/assets/icons/Cross.png; */
        /* background-size: contain; */
        margin-top: 75;
        margin-bottom: 100;
        opacity: 0;
        animation-name: fadeIn;
        animation-duration: 1s;
        animation-fill-mode: forwards;
        animation-delay: 0.5s;
    }
</style>